"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.spawnThread = void 0;
const g = global;
/**
 * Runs the given function in a custom thread, in a custom parallel runtime.
 *
 * _Note: Despite it's name, Threads are actually not spawned on demand and will be re-used. (Thread-Pool)_
 *
 * @example
 * ```ts
 * const result = await spawnThread(() => {
 *   const someValue = doExpensiveCalculation()
 *   return someValue
 * })
 * ```
 */

const spawnThread = g.spawnThread;
exports.spawnThread = spawnThread;
//# sourceMappingURL=index.js.map